import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { AuthGuard } from './auth/guard/auth.guard';
import { CreateRuleComponent } from './admin/create-rule/create-rule.component';
import { LoginComponent } from './auth/login/login.component';
import { GridComponent } from './grid/grid.component';
import { RulesComponent } from './rules/rules/rules.component';

const routes: Routes = [
  {
    path: '',
    component: RulesComponent
  },
  {
    path: 'login',
    component: LoginComponent
  },
  {
    path: 'admin',
    canActivate: [AuthGuard],
    children: [
      {
        path: 'create',
        component: CreateRuleComponent
      }
    ]
  }
];

@NgModule({
  imports: [RouterModule.forRoot(routes, { enableTracing: true })],
  exports: [RouterModule]
})
export class AppRoutingModule { }
