import { Component, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { User } from '../../class/user';
import { AuthService } from '../service/auth.service';

@Component({
  selector: 'app-login',
  templateUrl: './login.component.html',
  styleUrls: ['./login.component.scss']
})
export class LoginComponent implements OnInit {
  username = new FormControl('');
  password = new FormControl('');
  constructor(protected authService: AuthService, private route: ActivatedRoute, protected router: Router) { }

  onSubmit() {
    let user = new User();
    user.username = this.username.value;
    user.password = this.password.value;
    this.authService.user = user;
    const redirectUrl = this.route.queryParams
      .subscribe(value => {
        if (value?.returnUrl) {
          this.router.navigate([value.returnUrl]);
          return;
        }
        this.router.navigate(['']);
      })
  }
  ngOnInit(): void {

  }

}
