import { Injectable } from '@angular/core';
import { Rule } from '../../../api';

@Injectable({
  providedIn: 'root'
})
export class RuleDataService {
  getParagraphOfNextChild = (parentRule): string => `${parentRule.paragraph}.${parentRule.subRule.length + 1}`;
  filterRuleWithParentFromRootLayer = (rootLayerRule: Rule) => typeof rootLayerRule.parentRule !== 'number';

  compareRulesByParagraph = (ruleA: Rule, ruleB: Rule) => this.compareParahraph(ruleA.paragraph, ruleB.paragraph);


  compareParahraph(paragraphA: string, paragraphB: string): 0 | 1 | -1 {
    if (paragraphA === paragraphB) {
      return 0;
    }
    const paragrapASections = paragraphA.split('.');
    const paragrapBSections = paragraphB.split('.');
    if (+paragrapASections[0] > +paragrapBSections[0]) {
      return 1;
    }
    if (+paragrapASections[0] < +paragrapBSections[0]) {
      return -1;
    }
    if (+paragrapASections[0] === +paragrapBSections[0]) {
      let shiftedParagraphASections = paragrapASections;
      shiftedParagraphASections.shift();
      let shiftedParagraphBSections = paragrapBSections;
      shiftedParagraphBSections.shift();
      return this.compareParahraph(
        shiftedParagraphASections.join('.'),
        shiftedParagraphBSections.join('.'),
      )
    }
  }
  constructor() { }
}
